/*
 *     __   ___   _
 *    /  \ |   \ | | /\---------<ShellCode Generator Library>----------------->
 *   / /\ \| |\ \| |/ /
 *  / /__\ \    /|   /          libShellCode is an ORK's project!
 *  \______/ |\ \| | \          For comments, bug reports, etc ...
 *<--------|_| \_\_|\_\         contact me at orkmail<at>katamail<dot>com
 *
 *
 */


#include "codes.h"
#include "i386_codes.h"
#include "i386_bsd_codes.h"


/*
 * Function:    generate_i386_bsd_bind_SC()
 * Parameters:  char * prg      the path of the command to execute with the 
 *                              command line parameters
 *              int  setuid     0 = none
 *                              1 = execute setuid(0)
 *                              2 = execute setreuid(0, 0)
 *                              3 = execute setresuid(0, 0, 0)
 *              int  setgid     0 = none
 *                              1 = execute setgid(0)
 *                              2 = execute setregid(0, 0)
 *                              3 = execute setresgid(0, 0, 0)
 *              int chroot_evasion 0 = none
 *                              1 = evade chroot() before execve()
 *              int exit        0 = don't execute exit(0) 
 *                              1 = execute exit(0) after execve()
 *              int port        port to bind
 *              int fork        0 = don't perform fork() 
 *                              1 = perform fork() before program execution
 *              int  cripted    0 = not encripted
 *                              1 = XOR Encription
 * Return:      char *          the pointer to the ShellCode generated
 * Description: This function generates a ShellCode that bind a program to 
 *              a port.
 * Note:        Inspired by a bighawk code.
 *
 */

char *generate_i386_bsd_bind_SC(char *prg, int setuid, int setgid, int chroot_evasion, int exit, int port, int fork, int cripted)
{
  char *shellcode;

  initialize_codes(I386, BSD);
    
  shellcode = (char *) malloc(strlen(EXIT_0)+strlen("NOT SUPPORTED!!!") + 1);
  sprintf(shellcode, "%s%s\0", EXIT_0, "NOT SUPPORTED!!!");
    
  free_codes(I386, BSD);
  return shellcode;
}
